Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.connecterra.ale.dynamicconfig.api
Interface DynamicConfigFactory

All Known Implementing Classes:
  AbstractDynamicConfigFactory, DynamicConfigBeanFactory

    public interface DynamicConfigFactory

Factory for creating dynamic configuration classes.

Method Summary
`PluginParameterMeta` | `createBooleanMeta(String keyName, String displayName, String desc, boolean defaultValue)` Creates an optional boolean parameter meta with a default value.
`PluginParameterMeta` | `createLabelMeta(String keyName, String displayName, String desc)` Creates a label parameter meta.
`PluginParameterMeta` | `createNumericMeta(String keyName, String displayName, String desc, long defaultValue)` Creates an optional numeric parameter meta with a default value.
`PluginParameterMeta` | `createNumericMeta(String keyName, String displayName, String desc, long defaultValue, long min, long max)` Creates an optional numeric parameter meta with a default value and min-max constraint.
`PluginConfig` | `createPluginConfig(String metaKeyName, String name, String role)` Creates a new `PluginConfig` instance.
`PluginConfigParameter` | `createPluginConfigParameter(String metaKeyName)` Creates a new `PluginConfigParameter` instance.
`PluginMeta` | `createPluginMeta(String classType, String keyName, String displayName, String role)` Creates a new `PluginMeta` instance.
`PluginParameterConstraintDynamicSet` | `createPluginParameterConstraintDynamicSet(String role, String setID, Map params)` Creates a new `PluginParameterConstraintDynamicSet` instance.
`PluginParameterConstraintEnum` | `createPluginParameterConstraintEnum(List enumList)` Creates a new `PluginParameterConstraintEnum` instance.
`PluginParameterConstraintRangeNumeric` | `createPluginParameterConstraintRangeNumeric(long minValue, long maxValue)` Creates a new `PluginParameterConstraintRangeNumeric` instance.
`PluginParameterMeta` | `createPluginParameterMeta(String keyName, String displayName, String type)` Creates a new `PluginParameterMeta` instance.
`PluginParameterMeta` | `createRequiredBooleanMeta(String keyName, String displayName, String desc)` Creates a required boolean parameter meta.
`PluginParameterMeta` | `createRequiredNumericMeta(String keyName, String displayName, String desc)` Creates a required numeric parameter meta.
`PluginParameterMeta` | `createRequiredNumericMeta(String keyName, String displayName, String desc, long min, long max)` Creates a required numeric parameter meta, with a min-max constraint.
`PluginParameterMeta` | `createRequiredStringMeta(String keyName, String displayName, String desc)` Creates a required string parameter meta.
`PluginParameterMeta` | `createStringListMeta(String keyName, String displayName, String desc)` Creates a non-required, multi-valued string parameter meta.
`PluginParameterMeta` | `createStringMeta(String keyName, String displayName, String desc, String defaultValue)` Creates an optional string parameter meta with a default value.

Method Detail

### createPluginMeta

    PluginMeta createPluginMeta(String classType,
                                String keyName,
                                String displayName,
                                String role)

  Creates a new `PluginMeta` instance.

  Parameters:
    `classType` - fully qualified class name of the the plugin
    `keyName` - key name of the `PluginMeta` for the plugin
    `displayName` - display name of the `PluginMeta` for the plugin
    `role` - `PluginMeta.Role` to which the plugin belongs
  Returns:
    the newly created `PluginMeta`

### createPluginParameterMeta

    PluginParameterMeta createPluginParameterMeta(String keyName,
                                                  String displayName,
                                                  String type)

  Creates a new `PluginParameterMeta` instance.

  Parameters:
    `keyName` - key name of the parameter
    `displayName` - display name of the parameter
    `type` - type of the parameter. The types are defined in `PluginParameterMeta.Type`.
  Returns:
    the newly created `PluginParameterMeta`

### createPluginParameterConstraintEnum

    PluginParameterConstraintEnum createPluginParameterConstraintEnum(List enumList)

  Creates a new `PluginParameterConstraintEnum` instance.

  Parameters:
    `enumList` - list of allowed string values
  Returns:
    the newly created `PluginParameterConstraintEnum`

### createPluginParameterConstraintRangeNumeric

    PluginParameterConstraintRangeNumeric createPluginParameterConstraintRangeNumeric(long minValue,
                                                                                      long maxValue)

  Creates a new `PluginParameterConstraintRangeNumeric` instance.

  Parameters:
    `minValue` - minimum numeric value allowed
    `maxValue` - maximum numeric value allowed
  Returns:
    the newly created `PluginParameterConstraintRangeNumeric`

### createPluginParameterConstraintDynamicSet

    PluginParameterConstraintDynamicSet createPluginParameterConstraintDynamicSet(String role,
                                                                                  String setID,
                                                                                  Map params)

  Creates a new `PluginParameterConstraintDynamicSet` instance.

  Parameters:
    `role` - `PluginMeta.Role` to which the dynamic set belongs
    `setID` - the dynamic set identifier
    `params` - string to string map of parameters used to generate the dynamic set. Specific keys and values are determined by the setID and role.
  Returns:
    the newly created `PluginParameterConstraintDynamicSet`

### createPluginConfig

    PluginConfig createPluginConfig(String metaKeyName,
                                    String name,
                                    String role)

  Creates a new `PluginConfig` instance.

  Parameters:
    `metaKeyName` - key name of the `PluginMeta` for the plugin
    `name` - name of the plugin
    `role` - `PluginMeta.Role` to which this plugin belongs
  Returns:
    the newly created `PluginConfig`

### createPluginConfigParameter

    PluginConfigParameter createPluginConfigParameter(String metaKeyName)

  Creates a new `PluginConfigParameter` instance.

  Parameters:
    `metaKeyName` - key name of the parameter meta corresponding for the PluginConfigParameter that is to be created
  Returns:
    the newly created `PluginConfigParameter`

### createRequiredStringMeta

    PluginParameterMeta createRequiredStringMeta(String keyName,
                                                 String displayName,
                                                 String desc)

  Creates a required string parameter meta.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
  Returns:
    the newly created `PluginParameterMeta`

### createStringMeta

    PluginParameterMeta createStringMeta(String keyName,
                                         String displayName,
                                         String desc,
                                         String defaultValue)

  Creates an optional string parameter meta with a default value.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
    `defaultValue` - default value for this parameter
  Returns:
    the newly created `PluginParameterMeta`
  Throws:
    `IllegalArgumentException` - if null is passed in for default value

### createRequiredBooleanMeta

    PluginParameterMeta createRequiredBooleanMeta(String keyName,
                                                  String displayName,
                                                  String desc)

  Creates a required boolean parameter meta.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
  Returns:
    the newly created `PluginParameterMeta`

### createBooleanMeta

    PluginParameterMeta createBooleanMeta(String keyName,
                                          String displayName,
                                          String desc,
                                          boolean defaultValue)

  Creates an optional boolean parameter meta with a default value.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
    `defaultValue` - default value for this parameter
  Returns:
    the newly created `PluginParameterMeta`

### createRequiredNumericMeta

    PluginParameterMeta createRequiredNumericMeta(String keyName,
                                                  String displayName,
                                                  String desc)

  Creates a required numeric parameter meta.

  Parameters:
    `keyName` - key name of the parameter met
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
  Returns:
    the newly created `PluginParameterMeta`

### createRequiredNumericMeta

    PluginParameterMeta createRequiredNumericMeta(String keyName,
                                                  String displayName,
                                                  String desc,
                                                  long min,
                                                  long max)

  Creates a required numeric parameter meta, with a min-max constraint.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
    `min` - minimum value allowed for this parameter
    `max` - maximum value allowed for this parameter
  Returns:
    the newly created `PluginParameterMeta`

### createNumericMeta

    PluginParameterMeta createNumericMeta(String keyName,
                                          String displayName,
                                          String desc,
                                          long defaultValue)

  Creates an optional numeric parameter meta with a default value.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
    `defaultValue` - default value for this parameter
  Returns:
    the newly created `PluginParameterMeta`

### createNumericMeta

    PluginParameterMeta createNumericMeta(String keyName,
                                          String displayName,
                                          String desc,
                                          long defaultValue,
                                          long min,
                                          long max)

  Creates an optional numeric parameter meta with a default value and min-max constraint.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
    `defaultValue` - default value for this parameter
    `min` - minimum value allowed for this parameter
    `max` - maximum value allowed for this parameter
  Returns:
    the newly created `PluginParameterMeta`

### createLabelMeta

    PluginParameterMeta createLabelMeta(String keyName,
                                        String displayName,
                                        String desc)

  Creates a label parameter meta.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
  Returns:
    the newly created `PluginParameterMeta`

### createStringListMeta

    PluginParameterMeta createStringListMeta(String keyName,
                                             String displayName,
                                             String desc)

  Creates a non-required, multi-valued string parameter meta.

  Parameters:
    `keyName` - key name of the parameter meta
    `displayName` - display name of the parameter meta
    `desc` - description of the parameter
  Returns:
    the newly created `PluginParameterMeta`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at ${DOCSWEBROOT} Copyright 2007 BEA Systems Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD